/*
 * FaultExceed.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "Alert/AlertBase.h"

#ifndef ALERT_FAULTEXCEED_H_
#define ALERT_FAULTEXCEED_H_

namespace ALERT
{

class FaultExceed: public ALERT::AlertBase
{
private:
    bool m_fault;
public:
    bool fault;
public:
    FaultExceed();
    void setup(float time_sample);
    void configure(const AlertBaseConfiguration& config);
public:
    void reset();
public:
    void execute(float reference);
private:
    void (FaultExceed::*_execute)(float reference);
    void _execute_undef(float reference);
    void _execute_operational(float reference);
    //
};//FaultExceed()

} /* namespace ALERT */

#endif /* ALERT_FAULTEXCEED_H_ */
