/*
 * FRAMVariant.cpp
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "FRAM/FRAMVariant.h"

namespace FRAM
{
//CONSTRUCTOR
FRAMVariant::FRAMVariant():
        t(FRAM::FRAM_VARIANT_UNDEFINED),
        f(0)
//
{}//CONSTRUCTOR
//

FRAM::fram_variant_type_t FRAMVariant::get_type() const
{
    return t;
    //
}//
//

void FRAMVariant::set_float(float v)
{
    f = v;
    t = FRAM::FRAM_VARIANT_FLOAT;
    //
}//
//

void FRAMVariant::set_int16(int16_t v)
{
    i16 = v;
    t = FRAM::FRAM_VARIANT_INT16;
    //
}//
//
void FRAMVariant::set_int32(int32_t v)
{
    i32 = v;
    t = FRAM::FRAM_VARIANT_INT32;
    //
}//
//
void FRAMVariant::set_uint16(uint16_t v)
{
    u16 = v;
    t = FRAM::FRAM_VARIANT_UINT16;
    //
}//
//
void FRAMVariant::set_uint32(uint32_t v)
{
    u32 = v;
    t = FRAM::FRAM_VARIANT_UINT32;
    //
}//
//



void FRAMVariant::set_bool(bool v)
{
    b = v;
    t = FRAM::FRAM_VARIANT_BOOL;
    //
}//
//
float FRAMVariant::get_float() const
{
    return f;
    //
}//
//

int16_t FRAMVariant::get_int16() const
{
    return i16;
    //
}//
//
int32_t  FRAMVariant::get_int32() const
{
    return i32;
    //
}//
//
uint16_t FRAMVariant::get_uint16() const
{
    return u16;
    //
}//
//
uint32_t FRAMVariant::get_uint32() const
{
    return u32;
    //
}//
//


bool FRAMVariant::get_bool() const
{
    return b;
}//
//

}/* namespace FRAM */
