/*
 * HALBase.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include <math.h>
#include <stdint.h>
//
#include "F28335/DSP28x_Project.h"

#ifndef HAL_HALVIRTUAL_H_
#define HAL_HALVIRTUAL_H_

namespace HAL
{

typedef void (*pGPIO_FUNCTION)();


struct HALSetup
{
    pGPIO_FUNCTION gpio_setup;
    HALSetup():
        gpio_setup(0)
    {}
};//HALSetup


class HALBase
{
public:
    enum mode_t {UNDEFINED=0, OPERATIONAL=1};
protected:
    mode_t  m_mode;
    bool m_status;
public:
    HALBase();
public:
    mode_t get_mode() const;
    bool compare(mode_t mode) const;
    //
};//end class HALVirtual

} /* namespace HAL */

#endif /* HAL_HALVIRTUAL_H_ */
