/*
 * RUBUSCOPE.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#ifndef MODBUSRTU_RUBUSCOPE_H_
#define MODBUSRTU_RUBUSCOPE_H_

#include <math.h>
#include <stdint.h>

#include "framework.h"
#include "SYSCTRL/SystemEnvironment.h"
#include "MODBUSRTU/RUBUSRegister.h"
#include "MODBUSRTU/RUBUSTypes.h"


namespace MODBUSRTU
{

#define RUBUSCOPEARRAYLEN 100

struct RUBUSCOPEVariables
{
    uint16_t command;
    uint16_t response;
    uint16_t channel;
    uint16_t pointer;
    float data;
    RUBUSCOPEVariables(){}
};//RUBUSCOPEVariables



class RUBUSCOPE
{
private:
    SYSCTRL::SystemEnvironment& m_env;
    uint16_t m_len;
    float m_channels[9][RUBUSCOPEARRAYLEN];
public:
    RUBUSCOPE(SYSCTRL::SystemEnvironment& env);
};

} /* namespace MODBUSRTU */

#endif /* MODBUSRTU_RUBUSCOPE_H_ */
