/*
 * RUBUSDataBase.cpp
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "MODBUSRTU/RUBUSDataBase.h"

namespace MODBUSRTU
{

RUBUSDataBase::RUBUSDataBase():
        m_cell(),
        m_current_index_cell(0),
        m_index_cell(0),
        m_counter_cell(0),
        m_size_cell(NUMBER_RUBUSCELLS)
{}//


void RUBUSDataBase::add_register_bool  (uint16_t index, uint16_t readonly, bool*     param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bool(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_float (uint16_t index, uint16_t readonly, float*    param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_float(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_uint8 (uint16_t index, uint16_t readonly, uint8_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_uint8(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_uint16(uint16_t index, uint16_t readonly, uint16_t* param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_uint16(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_uint32(uint16_t index, uint16_t readonly, uint32_t* param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_uint32(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_int8  (uint16_t index, uint16_t readonly, int8_t*   param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_int8(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_int16 (uint16_t index, uint16_t readonly, int16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_int16(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_int32 (uint16_t index, uint16_t readonly, int32_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_int32(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//



void RUBUSDataBase::add_register_bit0  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit0(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit1  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit1(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit2  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit2(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit3  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit3(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit4  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit4(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit5  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit5(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit6  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit6(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit7  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit7(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit8  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit8(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit9  (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit9(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit10 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit10(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit11 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit11(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit12 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit12(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit13 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit13(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit14 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit14(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit15 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit15(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit16 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit16(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit17 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit17(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit18 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit18(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit19 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit19(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit20 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit20(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit21 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit21(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit22 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit22(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit23 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit23(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit24 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit24(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit25 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit25(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit26 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit26(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit27 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit27(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit28 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit28(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit29 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit29(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit30 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit30(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
void RUBUSDataBase::add_register_bit31 (uint16_t index, uint16_t readonly, uint16_t*  param)
{
    if(m_counter_cell < m_size_cell)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_counter_cell];
        cell.register_bit31(index, readonly, param);
        m_counter_cell++;
        //
    }//if
    //
}//
//
//#pragma CODE_SECTION("ramfuncs");
MODBUSRTU::RUBUSRegister& RUBUSDataBase::get_register(uint16_t index)
{
    m_current_index_cell = 0;
    for(m_index_cell = 0; m_index_cell < m_counter_cell; m_index_cell++)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_index_cell];
        if(cell.get_index() == index)
        {
            m_current_index_cell = m_index_cell;
            break;
            //
        }//if
        //
    }//for
    //
    return m_cell[m_current_index_cell];
    //
}//
//
//#pragma CODE_SECTION("ramfuncs");
void RUBUSDataBase::read_register(uint16_t index, RUBUS_REGISTER_32& data)
{
    m_current_index_cell = 0;
    for(m_index_cell = 0; m_index_cell < m_counter_cell; m_index_cell++)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_index_cell];
        if(cell.get_index() == index)
        {
            m_current_index_cell = m_index_cell;
            break;
            //
        }//if
        //
    }//for
    //
    data.all = m_cell[m_current_index_cell].read_register().all;
    //
}//
//
//#pragma CODE_SECTION("ramfuncs");
uint16_t RUBUSDataBase::write_register(uint16_t index, RUBUS_REGISTER_32 data)
{
    m_current_index_cell = 0;
    for(m_index_cell = 0; m_index_cell < m_counter_cell; m_index_cell++)
    {
        MODBUSRTU::RUBUSRegister& cell = m_cell[m_index_cell];
        if(cell.get_index() == index)
        {
            m_current_index_cell = m_index_cell;
            break;
            //
        }//if
        //
    }//for
    //
    return m_cell[m_current_index_cell].write_register(data.all);
    //
}//
//

} /* namespace MODBUSRTU */
