/*
 * AlgorithmBase.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include <math.h>
#include <stdint.h>

#include "SYSCTRL/SystemEnvironment.h"

#ifndef SYSCTRL_ALGORITHMBASE_H_
#define SYSCTRL_ALGORITHMBASE_H_

namespace SYSCTRL
{

class AlgorithmBase
{
protected:
    float m_voltage_a;
    float m_voltage_b;
    float m_voltage_c;
public:
    AlgorithmBase();
public:
    virtual void setup() = 0;
public:
    virtual void reset() = 0;
public:
    void get_ref_invertor_voltage(float& volt_a, float& volt_b, float& volt_c);
public:
    virtual void execute() = 0;
protected:
    void _execute_undef();
    virtual void _execute_run() = 0;
    //
};//AlgorithmBase

} /* namespace SYSCTRL */

#endif /* SYSCTRL_ALGORITHMBASE_H_ */
