/*
 * AlgorithmFault.cpp
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "SYSCTRL/AlgorithmFault.h"

namespace SYSCTRL
{
//CONSTRUCTOR
AlgorithmFault::AlgorithmFault(SYSCTRL::SystemEnvironment& env):
        SYSCTRL::AlgorithmBase(),
        m_env(env),
        _execute(&SYSCTRL::AlgorithmFault::_execute_undef)
//
{}//CONSTRUCTOR
//
void AlgorithmFault::setup()
{
    _execute = &SYSCTRL::AlgorithmFault::_execute_run;
    //
}//
//
#pragma CODE_SECTION("ramfuncs");
void AlgorithmFault::reset()
{}//
//
#pragma CODE_SECTION("ramfuncs");
void AlgorithmFault::execute()
{
    (this->*_execute)();
    //
}//
//
#pragma CODE_SECTION("ramfuncs");
void AlgorithmFault::_execute_run()
{
    //
    m_env.hardware.ref_control_order = ORDER_START;
    //
    m_voltage_a = FP_ZERO;
    m_voltage_b = FP_ZERO;
    m_voltage_c = FP_ZERO;
    //
}//
//
} /* namespace SYSCTRL */
