/*
 * AlgorithmSource.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include <math.h>
#include <stdint.h>


#ifndef SYSCTRL_ALGIRITHMSOURCE_H_
#define SYSCTRL_ALGIRITHMSOURCE_H_

#include "SYSCTRL/AlgorithmBase.h"
#include "SYSCTRL/HeadersFLTSYSLIB.h"

namespace SYSCTRL
{

class AlgorithmSource: public AlgorithmBase
{
private:
    SYSCTRL::SystemEnvironment& m_env;
private:
    float m_voltage_direct;
    float m_voltage_quadrature;
    float m_voltage_alpha;
    float m_voltage_beta;
    float m_voltage_a_gen;
    float m_voltage_b_gen;
    float m_voltage_c_gen;
    float m_voltage_a_relative;
    float m_voltage_b_relative;
    float m_voltage_c_relative;
    float m_ort_alpha;
    float m_ort_beta;
public:
    AlgorithmSource(SYSCTRL::SystemEnvironment& env);
public:
    void setup();
public:
    void reset();
public:
    void execute();
private:
    void (AlgorithmSource::*_execute)();
    void _execute_run();
    //
};//class AlgirithmSource

} /* namespace SYSCTRL */

#endif /* SYSCTRL_ALGIRITHMSOURCE_H_ */
