/*
 * AlgorithmWorkEntry.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include <math.h>
#include <stdint.h>


#ifndef SYSCTRL_ALGORITHMWORKENTRY_H_
#define SYSCTRL_ALGORITHMWORKENTRY_H_

#include "SYSCTRL/AlgorithmBase.h"
#include "SYSCTRL/HeadersFLTSYSLIB.h"

namespace SYSCTRL
{

class AlgorithmWorkEntry: public AlgorithmBase
{
private:
    SYSCTRL::SystemEnvironment& m_env;
public:
    AlgorithmWorkEntry(SYSCTRL::SystemEnvironment& env);

public:
    void setup();
public:
    void reset();
public:
    void execute();
private:
    void (AlgorithmWorkEntry::*_execute)();
    void _execute_run();
};

} /* namespace SYSCTRL */

#endif /* SYSCTRL_ALGORITHMWORKENTRY_H_ */
