/*
 * AlgorithmZero.cpp
 *
 *  Created on: 20  2022 .
 *      Author: geras
 */

#include "SYSCTRL/AlgorithmZero.h"

namespace SYSCTRL
{

//CONSTRUCTOR
AlgorithmZero::AlgorithmZero(SYSCTRL::SystemEnvironment& env):
        SYSCTRL::AlgorithmBase(),
        m_env(env),
        _execute(&SYSCTRL::AlgorithmZero::_execute_undef)
{}//CONSTRUCTOR

void AlgorithmZero::setup()
{
    _execute = &SYSCTRL::AlgorithmZero::_execute_run;
    //
}//
//
#pragma CODE_SECTION("ramfuncs");
void AlgorithmZero::reset()
{}//
//
#pragma CODE_SECTION("ramfuncs");
void AlgorithmZero::execute()
{
    (this->*_execute)();
    //
}//
//
#pragma CODE_SECTION("ramfuncs");
void AlgorithmZero::_execute_run()
{
    //
    m_env.hardware.ref_control_order = ORDER_START;
    //
    m_voltage_a = FP_ZERO;
    m_voltage_b = FP_ZERO;
    m_voltage_c = FP_ZERO;
    //
}//
//

} /* namespace SYSCTRL */
