/*
 * BaseComponent.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include <math.h>
#include <stdint.h>

#ifndef SYSCTRL_BASECOMPONENT_H_
#define SYSCTRL_BASECOMPONENT_H_

namespace SYSCTRL
{

class BaseComponent
{
public:
    enum mode_t {UNDEFINED, CONFIGURATE, OPERATIONAL};
protected:
    mode_t m_mode;
protected:
    float m_time_sample;
public:
    BaseComponent();
public:
    mode_t get_mode();
    bool compare(mode_t mode);
};

} /* namespace SYSCTRL */

#endif /* SYSCTRL_BASECOMPONENT_H_ */
