/*
 * TimeStartStop.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "DSP2833x_Device.h"     // DSP2833x Headerfile Include File
#include "DSP2833x_Examples.h"

#ifndef SYSCTRL_TIMEINTERVAL_H_
#define SYSCTRL_TIMEINTERVAL_H_

namespace SYSCTRL
{

class MeasureTimeInterval
{
private:
    CPUTIMER_VARS& m_CPUTimer;
    Uint32 m_timer_result;
    Uint32 m_timer_result_previous;
    Uint32 m_magic_number;
    Uint32 m_period;
    Uint32 m_tim;
    Uint32 m_counter;
public:
    MeasureTimeInterval(CPUTIMER_VARS& CPUTimer, Uint32 magic);
public:
    void start(void);
    void stop(void);
    void reset(void);
    //
};//end class MeasureTimeStartStop

} /* namespace SYSCTRL */

#endif /* SYSCTRL_TIMEINTERVAL_H_ */
