/*
 * MeasureTimePeriod.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "DSP2833x_Device.h"     // DSP2833x Headerfile Include File
#include "DSP2833x_Examples.h"

#ifndef SYSCTRL_MEASURETIMEPERIOD_H_
#define SYSCTRL_MEASURETIMEPERIOD_H_

namespace SYSCTRL
{

class MeasureTimePeriod
{
private:
    CPUTIMER_REGS& m_CPUTimer;
    //CPUTIMER_VARS& m_CPUTimer;
    Uint32 m_timer_result;
    Uint32 m_timer_result_previous;
    Uint32 m_magic_number;
    Uint32 m_period;
    Uint32 m_tim;
    Uint32 m_counter;
public:
    MeasureTimePeriod(CPUTIMER_REGS& pCPUTimer, Uint32 magic);
    void execute(void);
    void reset(void);
private:
    void (MeasureTimePeriod::*_execute)(void);
    void _execute_start(void);
    void _execute_scan(void);
    //
};//end class MeasureTimePeriod

} /* namespace SYSCTRL */

#endif /* SYSCTRL_MEASURETIMEPERIOD_H_ */
