/*
 * AnalogSignalStructure.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include <math.h>
#include <stdint.h>


#ifndef SYSCTRL_ANALOGSIGNALSTRUCTURE_H_
#define SYSCTRL_ANALOGSIGNALSTRUCTURE_H_

namespace SYSCTRL
{



struct ProjectionAnalogSignalStructure
{
    float active;
    float reactive;
    ProjectionAnalogSignalStructure():
        active(FP_ZERO),
        reactive(FP_ZERO)
    {}
};//ProjectionAnalogSignalStructure


struct RelativeAnalogSignalStructure
{
    float amplitude;
    float relative;
    void reset()
    {
        amplitude = FP_ZERO;
        relative = FP_ZERO;
    }
    RelativeAnalogSignalStructure():
        amplitude(FP_ZERO),
        relative(FP_ZERO)
    {}
};//AnalogSignalStructure


} /* namespace SYSCTRL */

#endif /* SYSCTRL_ANALOGSIGNALSTRUCTURE_H_ */
